Index: libabac/abac_internal.h
===================================================================
--- libabac/abac_internal.h	(revision 4f40c3e6cf53f7c95a2a544455682c85f601e846)
+++ libabac/abac_internal.h	(revision 2e9455f11fea0205b8b4b1306b5d0804cda72e10)
@@ -8,113 +8,53 @@
 #include <credentials/sets/mem_cred.h>
 
-#include "abac_list.h"
-#include "abac_stack.h"
-#include "abac_util.h"
+#include "abac_defines.h"
 
-#include "abac.h"
-
-char *abac_condition_typed_string(abac_condition_t *ptr);
-char *abac_condition_string(abac_condition_t *ptr);
-abac_condition_t *abac_condition_create(char *);
-abac_condition_t *abac_condition_create_from_aspect(abac_aspect_t *ptr);
-int abac_condition_set_aspect_ptr(abac_condition_t *ptr, abac_aspect_t *aptr);
-int abac_condition_set_aspect_string(abac_condition_t *ptr, char *str);
-int abac_condition_set_range_string(abac_condition_t *ptr);
-int abac_condition_is_range(abac_condition_t *ptr);
-abac_aspect_t *abac_condition_of_aspect(abac_condition_t *ptr);
-void abac_condition_add_range_integer_item(abac_condition_t *ptr, int itype, int val);
-void abac_condition_add_range_float_item(abac_condition_t *ptr, int itype, float val);
-void abac_condition_add_range_time_item(abac_condition_t *ptr, int itype, char* val);
-void abac_condition_add_range_urn_item(abac_condition_t *ptr, char *val);
-void abac_condition_add_range_string_item(abac_condition_t *ptr, char *val);void abac_condition_add_range_boolean_item(abac_condition_t *ptr, char* val);
-
-abac_aspect_t *abac_aspect_role_principal_new(char *principal_name);
-int abac_aspect_aspect_param_cnt(abac_aspect_t *ptr);
-char *abac_aspect_aspect_param_string(abac_aspect_t *ptr);
-abac_aspect_t *abac_aspect_linking_new(int, char*,char*, char*);
-abac_aspect_t *abac_aspect_oset_linking_new(char *, char *, char *);
-abac_aspect_t *abac_aspect_role_linking_new(char *, char *, char *);
-abac_aspect_t *abac_aspect_oset_object_new(abac_term_t *object);
-abac_aspect_t *abac_aspect_oset_principal_new(char *principal_name);
-abac_aspect_t *abac_aspect_oset_new(char *principal_name, char *oset_name);
-abac_aspect_t *abac_aspect_role_new(char *principal_name, char *role_name);
-abac_list_t *abac_aspect_prereqs(abac_aspect_t *ptr);
-abac_aspect_t *abac_aspect_intersection_new(abac_aspect_t *);
-abac_id_t *abac_aspect_get_issuer_id(abac_aspect_t *ptr);
-char *abac_aspect_object_name(abac_aspect_t *ptr);
-char *abac_aspect_linked_role_name(abac_aspect_t *ptr);
-char *abac_aspect_principal_name(abac_aspect_t *ptr);
-char *abac_aspect_aspect_name(abac_aspect_t *ptr);
-abac_aspect_t *abac_aspect_role_principal_create(char *principal_name);
-abac_aspect_t *abac_aspect_principal_new(int type, char *principal_name);
-abac_aspect_t *abac_aspect_new(int type, char *principal_name, char *aspect_name);
-abac_aspect_t *abac_aspect_object_new(int type, abac_term_t *object);
-void abac_aspect_dump(abac_aspect_t *ptr, char* offset);
-abac_term_t *abac_aspect_object_term(abac_aspect_t *ptr);
-char* abac_aspect_type_string(abac_aspect_t *ptr);
-char *abac_aspect_string_with_condition(abac_aspect_t *ptr);
-char* abac_aspect_get_issuer_keytype(abac_aspect_t *ptr);
-int abac_aspect_get_issuer_idtype(abac_aspect_t *ptr);
-char *abac_aspect_typed_string_with_condition(abac_aspect_t *ptr);
-char *abac_aspect_principal_principalname(abac_aspect_t *ptr);
-
-int abac_term_is_time_type(abac_term_t *term);
-char *abac_time_to_term(char *string);
-abac_term_t *abac_term_new(int, char *, int, char *, void *);
-abac_term_t *abac_term_named_new(int idtype, char *name);
-char *abac_item_val(abac_item_t *ptr);
-char *abac_term_to_time(char *string);
-char *abac_cn_with_sha(char*);
-char *abac_idtype_with_sha(char*);
-char *abac_term_type_name(abac_term_t *term);
-abac_condition_t *abac_term_constraint(abac_term_t *term);
-abac_term_t *abac_term_create(char*, char*, abac_condition_t*);
-
-void abac_condition_dump(abac_condition_t *ptr, char *offset);
-abac_list_t *abac_condition_range_list(abac_condition_t *ptr);
-
-void abac_term_dump(abac_term_t *ptr, char *offset);
-
-abac_item_t *abac_item_new(int itype, char *val);
-int abac_item_type(abac_item_t *);
-char* abac_item_val(abac_item_t *);
-
-int abac_param_list_cnt(abac_param_list_t *ptr);
-char* abac_param_list_string(abac_param_list_t *ptr);
-void abac_param_dump(abac_param_list_t *ptr, char *offset);
-char* abac_param_list_string_with_condition(abac_param_list_t *ptr);
-char* abac_param_list_typed_string_with_condition(abac_param_list_t *ptr);
-abac_list_t *abac_param_list(abac_param_list_t *ptr);
-abac_param_list_t *abac_param_list_new(abac_term_t *term);
-
-certificate_t *abac_attribute_issuer_cert(abac_attribute_t *ptr);
-certificate_t *abac_attribute_cert(abac_attribute_t *ptr);
-abac_attribute_t *abac_attribute_new(abac_id_t *issuer, certificate_t *cert, certificate_t *issuer_cert);
-abac_aspect_t *abac_attribute_tail(abac_attribute_t *ptr);
-abac_aspect_t *abac_attribute_head(abac_attribute_t *ptr);
-
-abac_id_credential_t *abac_id_credential_lookup(char *pname);
-abac_id_t *abac_id_new(int idtype,char *keyid, char *cn, certificate_t *cert);
-private_key_t *abac_id_privkey(abac_id_t *id);
-certificate_t *abac_id_cert(abac_id_t *id);
-abac_id_t *abac_id_keyid_new(char *keyid, char *cn, certificate_t *cert);
-char* abac_id_idtype_string(abac_id_t *id);
-char *abac_id_name(abac_id_t *id);
-
-char *abac_termtype_string(int i);
-char *abac_idtype_string(int);
-
-abac_credential_t *abac_credential_lookup(char *cred_string);
-abac_stack_t *abac_verifier_dump_creds();
-abac_stack_t *abac_verifier_dump_principals();
-
-extern int ABAC_IN_PROLOG;
-extern char *prologIt(char*);
-
-#define PROLOG(BODY) {  \
-    ABAC_IN_PROLOG++;      \
-    { BODY }               \
-    ABAC_IN_PROLOG--;      \
-} 
+/* used by abac_c */
+extern int abac_context_creds_count(abac_context_t *);
+extern int abac_context_id_creds_count(abac_context_t *);
+extern void abac_aspect_add_linked_param(abac_aspect_t *ptr, abac_term_t *param);
+extern void abac_aspect_add_param(abac_aspect_t *ptr, abac_term_t *param);
+extern char *abac_aspect_aspect_name(abac_aspect_t*);
+extern int abac_aspect_is_linking(abac_aspect_t *ptr) ;
+extern int abac_aspect_is_object(abac_aspect_t *ptr);
+extern int abac_aspect_is_principal(abac_aspect_t *ptr);
+extern char *abac_aspect_linked_role_name(abac_aspect_t*);
+extern abac_aspect_t *abac_aspect_linking_new(int, char*,char*, char*);
+extern abac_aspect_t *abac_aspect_new(int, char*, char*);
+extern char *abac_aspect_object_name(abac_aspect_t*);
+extern abac_aspect_t *abac_aspect_object_new(int type, abac_term_t *object);
+extern char *abac_aspect_principal_name(abac_aspect_t*);
+extern abac_aspect_t *abac_aspect_principal_new(int, char*);
+extern abac_aspect_t *abac_aspect_role_principal_create(char*);
+extern char *abac_aspect_string(abac_aspect_t*);
+extern char *abac_aspect_typed_string(abac_aspect_t*);
+extern abac_aspect_t *abac_attribute_head(abac_attribute_t *ptr);
+extern abac_aspect_t *abac_attribute_tail(abac_attribute_t *ptr);
+extern abac_aspect_t **abac_attribute_tail_vectorized(abac_attribute_t*);
+extern int abac_attribute_write_cert(abac_attribute_t*, FILE *out);
+extern void abac_condition_add_range_boolean_item(abac_condition_t *ptr, char* val);
+extern void abac_condition_add_range_float_item(abac_condition_t *ptr, int itype, float val);
+extern void abac_condition_add_range_integer_item(abac_condition_t *ptr, int itype, int val);
+extern void abac_condition_add_range_string_item(abac_condition_t *ptr, char *val);
+extern void abac_condition_add_range_time_item(abac_condition_t *ptr, int itype, char* val);
+extern void abac_condition_add_range_urn_item(abac_condition_t *ptr, char *val);
+extern abac_condition_t *abac_condition_create(char*);
+extern abac_condition_t *abac_condition_create_from_aspect(abac_aspect_t*);
+extern char *abac_condition_string(abac_condition_t*);
+extern char *abac_condition_typed_string(abac_condition_t*);
+extern abac_id_credential_t *abac_context_id_credential_lookup(abac_context_t *ctx, char *);
+extern int abac_context_load_attribute_attribute(abac_context_t *ctx, abac_attribute_t *ptr);
+extern int abac_context_load_id_enc_id_file_key_file(abac_context_t *ctx, char *filename, char *keyfilename, char *pfile);
+extern int abac_context_load_id_enc_idkey_file(abac_context_t *ctx, char *filename, char *pfile);
+extern int abac_context_load_id(abac_context_t *ctx, abac_id_t *id);
+extern int abac_context_load_id_id_key_files(abac_context_t *ctx, char *filename, char *keyfilename);
+extern int abac_context_load_id_idkey_file(abac_context_t *ctx, char *filename);
+extern int abac_id_load_enc_privkey_file(abac_id_t *ptr, char *keyfile, char *pfile);
+extern void abac_id_write_cert(abac_id_t *id, FILE *out);
+extern int abac_id_write_privkey(abac_id_t *id, FILE *out);
+extern abac_term_t **abac_param_list_vectorize(abac_param_list_t*);
+extern abac_param_list_t *abac_aspect_aspect_params(abac_aspect_t *);
+extern abac_param_list_t *abac_aspect_linked_role_params(abac_aspect_t *);
+extern abac_param_list_t *abac_aspect_aspect_params(abac_aspect_t *);
 
 
Index: libabac/abac_key.c
===================================================================
--- libabac/abac_key.c	(revision 4f40c3e6cf53f7c95a2a544455682c85f601e846)
+++ libabac/abac_key.c	(revision 2e9455f11fea0205b8b4b1306b5d0804cda72e10)
@@ -1,13 +1,6 @@
-
 /**
 **  abac_key.c
 **  holding a private_key 
 **/
-
-// include the GNU extension of asprintf
-#define _GNU_SOURCE
-
-#include <stdio.h>
-#include <time.h>
 #include <sys/types.h>
 #include <sys/stat.h>
@@ -15,15 +8,14 @@
 #include <fcntl.h>
 #include <sys/mman.h>
-#include <assert.h>
-
-#include "abac_internal.h"
+
+#include <credentials/keys/private_key.h>
+#include <credentials/sets/mem_cred.h>
+
+#include "abac_defines.h"
 #include "abac_util.h"
 
-extern chunk_t abac_get_potato_cb(int try, char *name);
-
 static int debug=0;
-//
+
 // abac_key object
-//
 // keyblob and potato are 'cleaned' explicitly
 struct _abac_key_t {
@@ -32,4 +24,7 @@
     chunk_t potato; // you know what, just as a hint
 };
+
+/* from abac_util */
+extern chunk_t abac_get_potato_cb(int, char*);
 
 /****************************************************************/
@@ -59,8 +54,6 @@
 static private_key_t *_load_privkey_chunk(chunk_t chunk)
 {
-    if(debug) { 
-        fprintf(stderr,"_load_privkey_chunk, ptr loc(%d):(%d)\n",
-                             (int) chunk.ptr, chunk.len);
-    }
+    DEBUG_PRINTF("_load_privkey_chunk, ptr loc(%d):(%d)\n",
+                                   (int) chunk.ptr, chunk.len);
     private_key_t *key = lib->creds->create(lib->creds,
         CRED_PRIVATE_KEY, KEY_RSA,
@@ -73,8 +66,6 @@
 static private_key_t *_load_enc_privkey_chunk(chunk_t chunk, chunk_t potato)
 {
-    if(debug) { 
-        fprintf(stderr,"_load_enc_privkey_chunk, ptr loc(%d):(%d)\n",
+    DEBUG_PRINTF("_load_enc_privkey_chunk, ptr loc(%d):(%d)\n",
                                       (int) chunk.ptr, chunk.len);
-    }
     mem_cred_t *mem;
     shared_key_t *shared;
@@ -240,12 +231,41 @@
 }
 
+static chunk_t _copy(chunk_t ptr)
+{
+    chunk_t blob=chunk_empty;
+    blob.ptr=strndup(ptr.ptr, ptr.len);
+    blob.len=ptr.len;
+    return blob;
+}
+
+
+abac_key_t *abac_key_copy(abac_key_t *ptr)
+{
+    abac_key_t *nptr = abac_xmalloc(sizeof(abac_key_t));
+
+    if(ptr->potato.len==0)
+        nptr->potato=chunk_empty;
+        else nptr->potato=_copy(ptr->potato);
+
+    if(ptr->filename!=NULL)
+        nptr->filename=abac_xstrdup(ptr->filename);
+        else nptr->filename=NULL;
+
+    if(ptr->keyblob.len==0)
+        nptr->keyblob=chunk_empty;
+        else nptr->keyblob=_copy(ptr->keyblob);
+    return nptr;
+}
+
 void abac_key_free(abac_key_t *ptr)
 {
-    if(ptr->potato.len != 0)
+    if(ptr->potato.len != 0) {
         chunk_clear(&ptr->potato);
-    if(debug) {
-         fprintf(stderr,"FREEEEE abac_key loc(%d)\n",(int)ptr->keyblob.ptr);
-    }
-    chunk_clear(&ptr->keyblob);
+    }
+    if(ptr->keyblob.len !=0) {
+        chunk_clear(&ptr->keyblob);
+    }
+    if(ptr->filename!=NULL)
+        free(ptr->filename);
     free(ptr);
 }
Index: libabac/abac_key.h
===================================================================
--- libabac/abac_key.h	(revision 2e9455f11fea0205b8b4b1306b5d0804cda72e10)
+++ libabac/abac_key.h	(revision 2e9455f11fea0205b8b4b1306b5d0804cda72e10)
@@ -0,0 +1,17 @@
+#ifndef __ABAC_KEY_H__
+#define __ABAC_KEY_H__
+
+#include "abac_defines.h"
+
+#include <credentials/keys/private_key.h>
+
+/* exported */
+/* for abac_id */
+extern private_key_t *abac_key_private_key(abac_key_t*);
+extern chunk_t abac_key_chunk(abac_key_t *);
+extern abac_key_t *abac_key_generate();
+extern abac_key_t *abac_key_copy(abac_key_t *);
+extern abac_key_t *abac_key_file_new(char *, chunk_t);
+extern abac_key_t *abac_key_chunk_new(chunk_t, chunk_t);
+
+#endif /* __ABAC_KEY_H__ */
Index: libabac/abac_list.c
===================================================================
--- libabac/abac_list.c	(revision 4f40c3e6cf53f7c95a2a544455682c85f601e846)
+++ libabac/abac_list.c	(revision 2e9455f11fea0205b8b4b1306b5d0804cda72e10)
@@ -1,7 +1,8 @@
 #include <stdlib.h>
 
+#include "abac_util.h"
 #include "abac_list.h"
-#include "abac_util.h"
 
+/****************************************************************/
 abac_list_t *abac_list_new(void) {
     abac_list_t *ret = abac_xmalloc(sizeof(abac_list_t));
Index: libabac/abac_list.h
===================================================================
--- libabac/abac_list.h	(revision 4f40c3e6cf53f7c95a2a544455682c85f601e846)
+++ libabac/abac_list.h	(revision 2e9455f11fea0205b8b4b1306b5d0804cda72e10)
@@ -1,4 +1,4 @@
-#ifndef __LIST_H__
-#define __LIST_H__
+#ifndef __ABAC_LIST_H__
+#define __ABAC_LIST_H__
 
 #include "utlist.h"
@@ -17,12 +17,4 @@
 };
 
-abac_list_t *abac_list_new(void);
-void abac_list_add(abac_list_t *list, void *elt);
-int abac_list_unique_add(abac_list_t *list, void *elt);
-void abac_list_prepend(abac_list_t *list, void *elt);
-int abac_list_remove(abac_list_t *list, void *elt);
-int abac_list_size(abac_list_t *list);
-void abac_list_free(abac_list_t *list);
-
 #define abac_list_foreach(LIST, CURRENT, BODY) do {  \
     abac_list_element_t *_elt;                  \
@@ -33,3 +25,12 @@
 } while (0)
 
-#endif /* __LIST_H__ */
+/* exported */
+extern abac_list_t *abac_list_new(void);
+extern void abac_list_add(abac_list_t *list, void *elt);
+extern int abac_list_unique_add(abac_list_t *list, void *elt);
+extern void abac_list_prepend(abac_list_t *list, void *elt);
+extern int abac_list_remove(abac_list_t *list, void *elt);
+extern int abac_list_size(abac_list_t *list);
+extern void abac_list_free(abac_list_t *list);
+
+#endif /* __ABAC_LIST_H__ */
Index: libabac/abac_m64.c
===================================================================
--- libabac/abac_m64.c	(revision 4f40c3e6cf53f7c95a2a544455682c85f601e846)
+++ libabac/abac_m64.c	(revision 2e9455f11fea0205b8b4b1306b5d0804cda72e10)
@@ -1,186 +1,96 @@
+/**
+**  abac_m64.c
+**/
 
 #include <stdio.h>
 #include <stdlib.h>
 #include <string.h>
+#include <assert.h>
+
+#include <credentials/certificates/certificate.h>
+
+#include "zlib.h"
+#define CHUNK 1024 /* 16384 */
 
 static int debug=0;
-char* abac_decode_string(char *);
+static int zip=1; /* to choose to compress/decompress */
 
-/* encode table */
-static const char encode64url[]="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/";
+/* 
+using strongswan's m64 utility so we can stay within the
+buf len size that strongwan set in using its certifiate 
+generation code (512)
+    chunk_t b64 = chunk_to_base64(chunk, NULL);
+    chunk_t chk = chunk_from_base64(base64, NULL);
+*/
 
-/* decode table Tables */
-/*
-static const char decode64url[]="=====rstuvwxyz========>?@ABCDEFGHIJKLMNOPQRSTUVW======XYZ[\\]^_=abcdefghijklmnopq";
-*/
-/*                                    6       14          26                   48      5557      65              81*/
-
-static const char decode64url[]="|$$$}rstuvwxyz{$$$$$$$>?@ABCDEFGHIJKLMNOPQRSTUVW$$$$$$XYZ[\\]^_`abcdefghijklmnopq";
-
-/* in 3, out 4 */
-static void _encode_block( char in[3], char out[4] , int len )
+static int _compress(char *string, int ilen, char*ostring)
 {
-    out[0] = encode64url[ in[0] >> 2 ];
-    out[1] = encode64url[ ((in[0] & 0x03) << 4) | ((in[1] & 0xf0) >> 4) ];
-    out[2] = (unsigned char) (len > 1 ? encode64url[ ((in[1] & 0x0f) << 2) | ((in[2] & 0xc0) >> 6) ] : '=');
-    out[3] = (unsigned char) (len > 2 ? encode64url[ in[2] & 0x3f ] : '=');
-if(0) {
-    printf("len: %d\n", len);
-    printf("IN: (%c)  (%c)  (%c)\n", in[0], in[1], in[2]);
-    printf("OUT: (%c)  (%c)  (%c) (%c)\n", out[0], out[1], out[2], out[3]);
-}
+    int olen=CHUNK;
+    int rc=compress(ostring,&olen,string,ilen); 
+    if(rc==Z_OK) { 
+        if(debug) fprintf(stderr,"compress from %d to %d\n", ilen, olen);
+        return olen;
+    }
+    return 0;
 }
 
-/* in 4, out 3 */
-void _decode_block( char in[4], char out[3] )
-{   
-    out[0] = (unsigned char ) (in[0] << 2 | in[1] >> 4);
-    out[1] = (unsigned char ) (in[1] << 4 | in[2] >> 2);
-    out[2] = (unsigned char ) (((in[2] << 6) & 0xc0) | in[3]);
-if(0) {
-    printf("IN: (%c)  (%c)  (%c) (%c)\n", in[0], in[1], in[2], in[3]);
-    printf("OUT: (%c)  (%c)  (%c)\n", out[0], out[1], out[2]);
-}
+/* all of these are deep copy of a string */
+char* abac_encode_string(char *string)
+{
+    assert(string);
+    char *ret=NULL;
+    char *ptr=string;;
+    int len=strlen(ptr);
+    char ostring[CHUNK];
+    if(zip) {
+        int olen=_compress(ptr, len,  ostring);
+        if(olen==0) { /* can not do the compress */
+           return NULL;
+        } else {
+           ptr=ostring;
+           len=olen;
+        }
+    } 
+    chunk_t orig = { ptr, len };
+    chunk_t b64 = chunk_to_base64(orig, NULL);
+    if(debug) fprintf(stderr,"abac_encode_string: (%s)\n",b64.ptr);
+    ret=strndup(b64.ptr,b64.len);
+    chunk_free(&b64);
+    return ret;
 }
 
-
-/*
-return a deep copy of encoded string
-*/
-char* abac_encode_string(char* string)
+static int _uncompress(char *string, int ilen, char *ostring)
 {
-    char *inbufptr, *outbufptr;
-    int len=strlen(string);
-    int olen, nlen;
-    char *orig_string, *new_string;
-    int hops;
-    int i;
-
-    if(len == 0) return strdup("");
-
-    if((len/3)*3 != len) {
-        hops=(len/3)+1;
-        olen=hops*3;
-        orig_string=malloc(sizeof(char)*olen); 
-        strcpy(orig_string,string);
-        for(i=len; i< olen; i++)
-            orig_string[i]=0;
-        } else {
-        hops=len/3;
-        olen=hops*3;
-        orig_string=strdup(string);
+    int olen=CHUNK;
+    int rc=uncompress(ostring,&olen,string,ilen); 
+    if(rc==Z_OK) { 
+        if(debug) fprintf(stderr,"uncompress from %d to %d\n", ilen, olen);
+        return olen;
     }
-    nlen=(olen*4/3 +1);
-    new_string = (char *) malloc(sizeof(char)*nlen);
- 
-    inbufptr=orig_string;
-    outbufptr=new_string;
-    if(debug) {
-       fprintf(stderr,"sizeof string %d\n", len);
-    }
-
-    int idx=0;
-    for(i=1; i<=hops;i++) {
-        int v=(len>(i*3))?3:(len-((i-1)*3));
-        _encode_block(inbufptr,outbufptr,v);
-        inbufptr=inbufptr+3;
-        outbufptr=outbufptr+4;
-        idx=idx+3;
-    }
-    free(orig_string);
-    new_string[nlen-1]='\0';
-
-    if(debug) {
-        char *d=abac_decode_string(new_string);
-        if(strcmp(d,string) !=0) {
-            fprintf(stderr,"ERROR, base64 encoding NOT OKAY\n");
-            fprintf(stderr,"orig,(%s)\n", string);
-            fprintf(stderr,"new,(%s)\n", new_string);
-            fprintf(stderr,"decode,(%s)\n",d);
-        } else fprintf(stderr," base64 encoding OKAY\n");
-        /* free(d); */
-    }
-    return new_string;
+    return 0;
 }
 
 char* abac_decode_string(char *string)
 {
-    char *inbufptr, *outbufptr;
+    assert(string);
+
+    char *ret=NULL;
     int len=strlen(string);
-    int nlen;
-    char *new_string;
-    char *orig_string;
-    int idx=0;
-    int v=0;
+    chunk_t b64 = { string, len };
+    chunk_t chk= chunk_from_base64(b64, NULL);
 
-    if(len==0) return strdup("");
-    int hops=len/4; // ignore any that is not in the size 4 blocks
-    new_string=(char *)malloc(sizeof(char)*(hops*3+1));
-    new_string[hops*3]='\0';
-    orig_string=strdup(string);
+    if(debug) fprintf(stderr,"abac_decode_string: (%s)\n",chk.ptr);
 
-    inbufptr=orig_string;
-    outbufptr=new_string;
-    char inbuf[4];
-    int i, j;
-
-    for(i=1; i<=hops; i++) {
-        for(j=0; j<4; j++) {
-            char c=inbufptr[j];
-            if(c > 122 || c <43) {
-                c=0;
-                } else {
-                   if(0) printf("from %d, (%c)\n", c, c);
-                   c=decode64url[c-43];
-                   if(0) printf("to %d, (%c)\n", c, c);
-            }
-            if(c) { 
-                if(c=='$') c=0;
-                    else c=c-61;
-            }
-            if(c) {
-                inbufptr[j]=(c-1);
-                } else {
-                    inbufptr[j]=0;
-            }              
-        }
-        _decode_block( inbufptr, outbufptr );
-        outbufptr=outbufptr+3;
-        inbufptr=inbufptr+4;
+    if(zip) {
+        char ostring[CHUNK];
+        int olen=_uncompress(chk.ptr, chk.len, ostring);
+        if(olen==0) { /* unable to uncompress the string!! */
+            ret=NULL;
+        } else ret=strndup(ostring,olen);
+    } else {
+        ret=strndup(chk.ptr, chk.len);
     }
-    free(orig_string);
-    return new_string;
+    chunk_free(&chk);
+    return ret;
 }
 
-
-/*****************
-int main( int argc, char **argv )
-{
- 
-    if(argc != 2) return 1;
-
-    FILE *infile = fopen( argv[1], "r" );
-
-    int num=1000;
-    char *string=(char *)malloc(sizeof(char)*num);
-
-    int cnt=getline(&string,&num,infile);
-    fclose(infile);
-    if(cnt==0) return 0;
-    if(string[cnt-1]=='\n')
-        string[cnt-1]='\0';
-
-    char *i=abac_encode_string(string);
-    printf("encoding into (%s)\n", i);
-    char *o=abac_decode_string(i);
-    printf("decode into (%s)\n", o);
-
-    printf(" %d:%d:%d\n", strlen(string),strlen(i), strlen(o));
-    if(strcmp(string,o)==0)
-         printf("OKAY \n");
-         else
-              printf("NOT OKAY \n");
-    free(string);
-    free(o);
-}
-****************/
Index: libabac/abac_m64.h
===================================================================
--- libabac/abac_m64.h	(revision 2e9455f11fea0205b8b4b1306b5d0804cda72e10)
+++ libabac/abac_m64.h	(revision 2e9455f11fea0205b8b4b1306b5d0804cda72e10)
@@ -0,0 +1,8 @@
+#ifndef __ABAC_M64_H__
+#define __ABAC_M64_H__
+
+/* exported */
+extern char* abac_decode_string(char *);
+extern char* abac_encode_string(char *);
+
+#endif /* __ABAC_M64_H__ */
